/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2203 from the
 * contents of Curve25519.xs. Do not edit this file, edit Curve25519.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Curve25519.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#if USE_X64
#include "curve25519-donna-c64.c"
#else
#include "curve25519-donna.c"
#endif

static u8* S_get_buffer(pTHX_ SV* variable, const char* name) {
	STRLEN len;
	u8* ret = (u8*) SvPV(variable, len);
	if (len != 32)
		Perl_croak(aTHX_ "%s requires 32 bytes", name);
	return ret;
}
#define get_buffer(variable, name) S_get_buffer(aTHX_ variable, name)

typedef u8 keybuffer[32];
typedef const u8* keyptr;

static const keybuffer basepoint = {9};

#line 36 "Curve25519.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 88 "Curve25519.c"

XS(XS_Crypt__Curve25519_curve25519_public_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Curve25519_curve25519_public_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "secret, base = 9");
    {
	keyptr	secret = get_buffer(ST(0), "Secret key");
	keyptr	base = items > 1 ? get_buffer(ST(1), "Basepoint") : basepoint;
	keybuffer	RETVAL;
	dXSTARG;
#line 35 "Curve25519.xs"
    curve25519_donna(RETVAL, secret, base);
#line 107 "Curve25519.c"
	XSprePUSH; PUSHp(RETVAL, 32);
    }
    XSRETURN(1);
}


XS(XS_Crypt__Curve25519_curve25519_shared_secret); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Curve25519_curve25519_shared_secret)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "secret, public");
    {
	keyptr	secret = get_buffer(ST(0), "Secret key");
	keyptr	public = get_buffer(ST(1), "Public key");
	keybuffer	RETVAL;
	dXSTARG;
#line 46 "Curve25519.xs"
    curve25519_donna(RETVAL, secret, public);
#line 132 "Curve25519.c"
	XSprePUSH; PUSHp(RETVAL, 32);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__Curve25519); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__Curve25519)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXS("Crypt::Curve25519::curve25519_public_key", XS_Crypt__Curve25519_curve25519_public_key, file);
        cv = newXS("Crypt::Curve25519::curve25519_shared_secret", XS_Crypt__Curve25519_curve25519_shared_secret, file);
        XSANY.any_i32 = 0 ;
        cv = newXS("Crypt::Curve25519::curve25519", XS_Crypt__Curve25519_curve25519_shared_secret, file);
        XSANY.any_i32 = 1 ;
    }
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

